#include <ansi_c.h>
#include <analysis.h>
#include <cvirte.h>


/* Calling sequence  calc, setup, realACF.. writeRealACFtoCSV*/
/* typedef TAU */

extern double __stdcall calcRealACFdutyFactor(double meanCountRate_cps,long clockPeriod_ns);
/* RTN: dutyFactor=1/(average number of clock cycles between photons) */
extern long __stdcall calcRealACFmtau(long mdelay_ns, long clockPeriod_ns); 
/* INPUT: maximum required delay time for acf, duty factor, RTN: buffer size (mtau) */

extern long __stdcall setupRealACF(long mtau,double dutyFactor, double clock_ns); 
/* INPUT: buffer size (mtau), duty factor, RTN: maximum delay time (memory allocated)*/

extern long __stdcall realACFraw(long tau); 
/* INPUT: interphoton delay time  RTN: tau if update of delaytime and acf arrays OK */

extern long __stdcall writeRealACFraw2CSV(char *fnameCSV);
/* INPUT: filename RTN: SUCCESS if CSV file is written successfully */

//extern long __stdcall realACFnormalized(void);
/* INPUT: none RTN: It takes the integer data and creates a normalized acf (not include SIGMA) */
//extern long __stdcall writeRealACFnormalized2CSV(char *fnameCSV);
/* INPUT: filename RTN: SUCCESS if CSV file is written successfully */

//extern long __stdcall ACFnormalized(void);
extern double __stdcall ACFFit1(void);

//extern void _stdcall getrawacf(long *acfraw);
//extern void _stdcall getacfnormalized(double *acfnormalized);
//extern void _stdcall getACFFit(double *acfnormalized, double *acfx);

extern void __stdcall realACFrawArrIO(long *delay, long *acf, long tau, long *idelay, long mtau, long mdelay);
//extern void __stdcall realACFnormalizedArrIO(double *nacf, long *acf, long mtau);

extern void __stdcall ACFsetupArrIO(long arrsize, const double clock_ns);
extern double __stdcall  ACFFit1ArrIO(long *yarr, long arrsize, double *fityarr, double *fitcoef, long iter,long guess);

extern void __stdcall file2acf(char *cfn, char *dfn, long mtau, double dutyFactor, double clock_ns);
extern void __stdcall ACFFree(void);


//extern void __stdcall ACFFit2(double *yarr, double *xarr, long arrsize, double *fityarr, double *fiterror, long iter);
//extern void __stdcall ACFFit3(double *yarr, double *xarr, long arrsize, double *fityarr, double *fiterror, long iter);

 
