#include <ansi_c.h>
//==============================================================================
//
// Title:       histo
// Purpose:     A short description of the library.
//
// Created on:  2008/3/31 at U 02:22:12 by Hsu-Yang Lee.
// Copyright:   NTU. All Rights Reserved.
//
//==============================================================================

//==============================================================================
// Include files

#include <utility.h>
#include "histo.h"
#define VERSION 20070818

//==============================================================================
// Constants

//==============================================================================
// Types

//==============================================================================
// Static global variables

//==============================================================================
// Static functions

//==============================================================================
// Global variables
long *histo;
long histoMax;
long lbound, ubound;
long binitv;

//==============================================================================
// Global functions

void __stdcall addpnt(long ipt)
{
	if(ipt>=lbound)histo[(long)floor(((double)(ipt-lbound))/binitv)]++;
}

void __stdcall addpntArrIO(long *histoarr, unsigned long ipt)
{
	if(ipt>=lbound)histoarr[(long)floor(((double)(ipt-lbound))/binitv)]++;
}

void __stdcall setupHisto(long lb, long ub, long itv){
	lbound=lb;
	ubound=ub;
	binitv=itv;
	histoMax=(long)ceil(((double)(ub-lb))/binitv);
	histo = (long *) calloc(histoMax+2,sizeof(long));

	if(histo==NULL)goto error;
	return;
error:
	fprintf(stderr,"setupHisto: ERROR Memory allocation failed\n");
	return;
}

void __stdcall getHistoCopy(long *histoArr)
{
	long i;
	for(i=0;i<histoMax+2;i++)
		histoArr[i]=histo[i];
}
/*
HISTO_API void addpnt2Histo(long d){
	if(d>histoMax)goto error;
	histo[d]++;
	return;
error:
  fprintf(stderr,"addpnt2Histo: WARNING data %ld > histoMax(%ld)\n",
		d,histoMax);
	return;
}

HISTO_API void getHisto(long *histo){return;}
*/
  
void __stdcall writeHisto(char *fname){
	long i;
	FILE *fout=fopen(fname,"w");
	if(fout==NULL)goto error;
	for(i=0;i<=histoMax+1;i++)fprintf(fout,"%ld\n",histo[i]);
	fclose(fout);
	return;
error:
	fprintf(stderr,"writeHisto: ERROR Unable to open output file '%s'\n",fname);
	return;
}

void __stdcall clearHisto(void){free(histo);}

void __stdcall file2acf(char *cfn, char *dfn, long lb, long ub, long itv)
{
	long i=0, err=0;
	long lngipt=0;
	FILE* fsrc=fopen(cfn, "rb");
	FILE *fdes;
	
	
	setupHisto(lb, ub, itv);
	while(feof(fsrc)==0)
	{
		err=fread (&lngipt, sizeof(long), 1, fsrc);
		addpnt(lngipt);
	}
	fclose(fsrc);
	fdes=fopen(dfn,"w");
	if(fdes==NULL)goto error;					
	for(i=0;i<histoMax;i++)fprintf(fdes,"%d\n",histo[i]);
	fclose(fdes);
	return;
error:
	return;
	
}

//==============================================================================
// DLL main entry-point functions

int __stdcall DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason) {
        case DLL_PROCESS_ATTACH:
            if (InitCVIRTE (hinstDLL, 0, 0) == 0)
                return 0;     /* out of memory */
            break;
        case DLL_PROCESS_DETACH:
            CloseCVIRTE ();
            break;
    }
    
    return 1;
}

int __stdcall DllEntryPoint (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    /* Included for compatibility with Borland */

    return DllMain (hinstDLL, fdwReason, lpvReserved);
}
