#include <stdio.h>
#include <math.h>
#include "ipt_in.h"
#include <stdlib.h>
#define FILELENGTH 10000

#define EXPTAU 7

#define A 48271L
#define M 2147483647L
#define Q (M/A)
#define R (M%A)
static unsigned long seed = 1;
double ranExponential(double tau);

int createTestBinaryIPTfile(char mode);

int main(void){
		int userInput;
		printf("Create test binary file of IPT data? [1/0]>>");
		if(fgetc(stdin)!='1'){
			printf("skipping creation of test file -- using user data.");
			return(0);
		}
		printf("Interphoton Time (ipt) file type\n\t" 
			"[c] Constant(5)\n\t"
			"[e] Random Exponential>5, tao=%d; \n\t"
			"[s] 0,3,2,3,9,5\n\t"
			"[f] Sample Experimental File >> ",EXPTAU);
		fgetc(stdin);
		userInput=fgetc(stdin);
		fgetc(stdin);
		createTestBinaryIPTfile(userInput);
		return(0);
}

double ranExponential(double tau){
	double ranNum;
	long tmpSeed;
	tmpSeed = A*(seed%Q)-R*(seed/Q);
	if(tmpSeed>=0)seed = tmpSeed;
	else seed = tmpSeed+M;
	ranNum = (double) seed/M;
	return( - tau * log(ranNum));
}


int createTestBinaryIPTfile(char mode){
	FILE *fIPTout=fopen("ipt.bin","wb");
	IPTdata iptdata=5;
	long j;
	long fileLength=FILELENGTH;
	fprintf(stderr,"createTestBinaryIPTfile (ipt.bin): mode %c  ",mode);
	if(fIPTout==NULL)goto error;
	switch(mode){
		case 'c' : 
			for(j=0;j<fileLength;j++)
				fwrite(&iptdata,sizeof(IPTdata),1,fIPTout);
			fprintf(stderr," %ld points written\n",fileLength);
			break;
		case 'e' :	
			for(j=0;j<fileLength;j++){
				iptdata= (IPTdata) (5 + ranExponential((double)EXPTAU));
				fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			}
			fprintf(stderr," %ld points written\n",fileLength);
			break;
		case 's' :
			iptdata=3;
			fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			iptdata=2;
			fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			iptdata=3;
			fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			iptdata=9;
			fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			iptdata=5;
			fwrite(&iptdata,sizeof(IPTdata),1,fIPTout); 
			fprintf(stderr," 4 points written\n");			
			break;			
		case 'f':
			system("copy ipt-real.bin ipt.bin"); break;
		default:
			goto error;
	}	
	fclose(fIPTout);

	return(0);
	error:
		fputs("ERROR ",stderr); 
		if(fIPTout==NULL)fputs("cannot open 'ipt.bin' to write\n",stderr);
		else fputs("invalid mode\n",stderr);
	return(1);
}
