   //==============================================================================
//
// Title:       ACF
// Purpose:     A short description of the interface.
//
// Created on:  2008/4/20 at U 07:21:15 by Hsu-Yang Lee.
// Copyright:   NTU. All Rights Reserved.
//
//==============================================================================

#ifndef __ACF_H__
#define __ACF_H__

#ifdef __cplusplus
    extern "C" {
#endif

//==============================================================================
// Include files

#include "cvidef.h"

//==============================================================================
// Constants

//==============================================================================
// Types

//==============================================================================
// External variables

//==============================================================================
// Global functions

extern double __stdcall calcRealACFdutyFactor(double m,long c);
extern long __stdcall calcRealACFmtau(long m, long c);
extern long __stdcall setupRealACF(long mtau,double dutyFactor, double clock_ns);
extern long __stdcall realACFraw(long tau); 
extern void __stdcall realACFnorm(char *dst);  
extern double __stdcall  fitRealACF(long maxiter); 
extern void _stdcall getRealACF(long *acfarr); 
extern void _stdcall getRealACFnorm(double *acfnorm);  
extern void _stdcall getRealACFfit(double *dblacffit, double *acfx);      
extern void __stdcall freeRealACF(void);
extern void __stdcall file2acf(char *cfn, char *dfn, long mtau, double dutyFactor, double clock_ns);
extern void __stdcall getACFcnt(unsigned __int64 *acntpt, unsigned __int64 *tcntpt);
extern void __stdcall resetrealACF(void);


#ifdef __cplusplus
    }
#endif

#endif  /* ndef __ACF_H__ */
