#include <stdio.h>
#include <stdlib.h>
struct TT {
	long width; /* width of bin in terms of clock period */
	long time; /* time (in clock cycles) from start of current bin */
	long count; /* # photons in current bin */
	long empty; /* # empty bins that need to be 0 in time trace */
} tt;
FILE *ftt;

long setupIpt2tt(double binWidth_s,double clockPeriod_s, char *fname){
	if((ftt=fopen(fname,"w"))==NULL)goto error;
	tt.width=(long) (binWidth_s/clockPeriod_s);
	tt.time=0;
	tt.count=1;
	tt.empty=0;
	printf("setupIpt2tt: binWidth=%.2e[s] clockPeriod=%.2e[s]" 
		"-->width=%ld\n",binWidth_s,clockPeriod_s,tt.width); 	
	return(tt.width);
error:
	printf("setupIpt2tt: FATAL ERROR cannot open %s for output.\n",fname);
	return(0);
}

void ipt2tt(unsigned long tau){
	/* 3 cases: bin time not up, next bin, many empty bins */
	long k;
	tt.time+=tau;
	if(tt.time<tt.width)tt.count++; /* still within time of single bin */
	else{  /* have left the bin : output total, write empty bins */
		tt.empty = tt.time / tt.width - 1;
		fprintf(ftt,"%ld\n",tt.count);
		for(k=0;k<tt.empty;k++)fprintf(ftt,"0\n");
		tt.time%=tt.width;
		tt.count=1;
		tt.empty=0;
	}
	return;
}

